const nsCipherInfoService = "@mozilla.org/security/cipherinfo;1";
const nsICipherInfoService = Components.interfaces.nsICipherInfoService;
const nsICipherInfo = Components.interfaces.nsICipherInfo;
function onLoad()
{
  var cipher_name = self.name;  
  var cipher_info_service = Components.classes[nsCipherInfoService].getService(nsICipherInfoService);
  var cipher = cipher_info_service.getCipherInfoByPrefString(self.name);
  var info_name = document.getElementById("name");
  var info_encryption = document.getElementById("encryption");
  var info_authAlg = document.getElementById("authAlg");
  var info_keyAlg = document.getElementById("keyAlg");
  var info_keySize = document.getElementById("keySize");
  var info_macAlg = document.getElementById("macAlg");
  var info_fips = document.getElementById("fips");
  var info_exportable = document.getElementById("exportable");
  try {
    info_name.setAttribute("value", cipher.longName);
    info_encryption.setAttribute("value", cipher.symCipherName);
    info_authAlg.setAttribute("value", cipher.authAlgorithmName);
    info_keyAlg.setAttribute("value", cipher.keaTypeName);
    info_keySize.setAttribute("value", cipher.effectiveKeyBits);
    info_macAlg.setAttribute("value", cipher.macAlgorithmName);
    if (cipher.isFIPS) {
      info_fips.removeAttribute("collapsed");
    }
    else {
      info_fips.setAttribute("collapsed", "true");
    }
    if (cipher.isExportable) {
      info_exportable.removeAttribute("collapsed");
    }
    else {
      info_exportable.setAttribute("collapsed", "true");
    }
  }
  catch (e) {
  }
}